#include <gtk/gtk.h>
#include <string.h>
#include <time.h>

void init_genrand(unsigned long s);
unsigned long genrand_int32(void);

GtkWidget* spin_length;
GtkWidget* check_shurui[4];
GtkWidget* entry_pass;

const char* passchar[4]={
	"ABCDEFGHIJKLMNOPQRSTUVWXYZ",
	"abcdefghijklmnopqrstuvwxyz",
	"0123456789",
	"!\"#$%&'()*+,-./:;<=>?@[\\]^_`{|}~"
};

void makepass(GtkWidget *button, gpointer user_data) {
	int length;
	int i;
	int mozinum;
	char passgen[300]={0};
	char pass[300]={0};
	//パスワードの長さを得る
	length=(int)gtk_spin_button_get_value((GtkSpinButton*)spin_length);
	if(length<1)length=1;
	if(length>256)length=256;
	//パスワードに使う文字を得る
	for(i=0;i<4;i++) {
		if(GTK_TOGGLE_BUTTON(check_shurui[i])->active) {
			strcat(passgen,passchar[i]);
		}
	}
	mozinum=strlen(passgen);
	if(mozinum>0) {
		//パスワードを作成する
		for(i=0;i<length;i++) {
			pass[i]=passgen[genrand_int32()%mozinum];
		}
	}
	//パスワードを表示する
	gtk_entry_set_text((GtkEntry*)entry_pass,pass);
}

void makegui(GtkWidget *window) {
	GtkWidget* table;
	GtkWidget* label_length;
	GtkAdjustment* length_adj;
	GtkWidget* button_run;
	GtkWidget* label_pass;
	//テーブルを作成
	table=gtk_table_new(4,4,TRUE);
	gtk_container_add (GTK_CONTAINER (window), table);
	//パスワードの長さを設定
	label_length=gtk_label_new("パスワードの長さ");
	length_adj=(GtkAdjustment*)gtk_adjustment_new(8.0,1.0,256.0,1.0,5.0,0.0);
	spin_length=gtk_spin_button_new(length_adj,1.0,0);
	gtk_table_attach_defaults(GTK_TABLE(table),label_length,0,2,0,1);
	gtk_table_attach_defaults(GTK_TABLE(table),spin_length,2,4,0,1);
	//パスワードに使う文字を設定
	check_shurui[0]=gtk_check_button_new_with_label("英大文字");
	check_shurui[1]=gtk_check_button_new_with_label("英小文字");
	check_shurui[2]=gtk_check_button_new_with_label("数字");
	check_shurui[3]=gtk_check_button_new_with_label("記号");
	gtk_toggle_button_set_active((GtkToggleButton*)check_shurui[0],TRUE);
	gtk_toggle_button_set_active((GtkToggleButton*)check_shurui[1],TRUE);
	gtk_table_attach_defaults(GTK_TABLE(table),check_shurui[0],0,1,1,2);
	gtk_table_attach_defaults(GTK_TABLE(table),check_shurui[1],1,2,1,2);
	gtk_table_attach_defaults(GTK_TABLE(table),check_shurui[2],2,3,1,2);
	gtk_table_attach_defaults(GTK_TABLE(table),check_shurui[3],3,4,1,2);
	//パスワード作成ボタン
	button_run=gtk_button_new_with_label("作成");
	g_signal_connect (G_OBJECT(button_run),"clicked",
		G_CALLBACK(makepass),NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),button_run,0,4,2,3);
	//パスワードを表示
	entry_pass=gtk_entry_new();
	gtk_entry_set_editable((GtkEntry*)entry_pass,FALSE);
	label_pass=gtk_label_new("パスワード");
	gtk_table_attach_defaults(GTK_TABLE(table),label_pass,0,1,3,4);
	gtk_table_attach_defaults(GTK_TABLE(table),entry_pass,1,4,3,4);
}

int main(int argc, char** argv){
	GtkWidget *window;

	//メルセンヌツイスタを初期化する
	init_genrand((unsigned long)time(NULL));

	//gtkを初期化する。おまじない。
	gtk_init(&argc,&argv);

	//ウインドウウィジェットを作成する。
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	//ウインドウの大きさを指定
	gtk_widget_set_size_request(window,320,180);
	
	//ウインドウのタイトルを指定
	gtk_window_set_title((GtkWindow*)window,"パスワードジェネレータ");
	
	//ウィンドウをリサイズできなくする
	gtk_window_set_resizable((GtkWindow*)window,FALSE);
 
	//ウインドウを閉じるときにプログラムも終了する。
	g_signal_connect(window, "destroy",
		G_CALLBACK(gtk_main_quit), NULL);
 
 	//GUIを作成
 	makegui(window);
 
	//ウインドウを表示
	gtk_widget_show_all(window);
 
	gtk_main();
 
	return 0;
}
